From b147720ca68a120efdf8f20c58cb3499901e6d61 Mon Sep 17 00:00:00 2001
From: Bharath Rupireddy <bharath.rupireddyforpostgres@gmail.com>
Date: Fri, 21 Oct 2022 14:29:27 +0000
Subject: [PATCH v1] Fix assertion failure in do_pg_abort_backup()

---
 src/backend/access/transam/xlog.c | 11 ++++++-----
 1 file changed, 6 insertions(+), 5 deletions(-)

diff --git a/src/backend/access/transam/xlog.c b/src/backend/access/transam/xlog.c
index dea978a962..104309c56f 100644
--- a/src/backend/access/transam/xlog.c
+++ b/src/backend/access/transam/xlog.c
@@ -8841,11 +8841,12 @@ do_pg_abort_backup(int code, Datum arg)
 {
 	bool		during_backup_start = DatumGetBool(arg);
 
-	/* Only one of these conditions can be true */
-	Assert(during_backup_start ^
-		   (sessionBackupState == SESSION_BACKUP_RUNNING));
-
-	if (during_backup_start || sessionBackupState != SESSION_BACKUP_NONE)
+	/*
+	 * When either of these were true, we know that the runningBackups has
+	 * already been incremented, hence decrement it.
+	 */
+	if (during_backup_start ||
+		sessionBackupState == SESSION_BACKUP_RUNNING)
 	{
 		WALInsertLockAcquireExclusive();
 		Assert(XLogCtl->Insert.runningBackups > 0);
-- 
2.34.1

